/**
* Copyright (C) 2015 EDIT
* European Distributed Institute of Taxonomy
* http://www.e-taxonomy.eu
*
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/
package eu.etaxonomy.taxeditor.editor.key.polytomous.operation;

import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IProgressMonitor;

import eu.etaxonomy.cdm.api.application.CdmChangeEvent.Action;
import eu.etaxonomy.cdm.model.common.CdmBase;
import eu.etaxonomy.cdm.model.description.PolytomousKeyNode;
import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
import eu.etaxonomy.taxeditor.operation.RemotingCdmDefaultOperation;

/**
 * @author cmathew
 * @date 21 Jul 2015
 *
 */
public class RemotingCreatePolytomousKeyNodeOperation extends RemotingCdmDefaultOperation {

    private final PolytomousKeyNode parentNode;
    private PolytomousKeyNode childNode;
    /**
    *
    */
   protected IPostOperationEnabled postOperationEnabled;

    public PolytomousKeyNode getChildNode() {
        return childNode;
    }

    private final static String LABEL = Messages.RemotingCreatePolytomousKeyNodeOperation_CREATE_KEY;

    public RemotingCreatePolytomousKeyNodeOperation(Object source,
            boolean async,
            PolytomousKeyNode parentNode, IPostOperationEnabled postOperationEnabled){
        super(LABEL, Action.Create, source, async);
        this.parentNode = parentNode;
        this.postOperationEnabled = postOperationEnabled;
    }

    /* (non-Javadoc)
     * @see eu.etaxonomy.taxeditor.operation.RemotingCdmSimpleOperation#doSimpleExecute(org.eclipse.core.runtime.IProgressMonitor, org.eclipse.core.runtime.IAdaptable)
     */
    @Override
    protected CdmBase doSimpleExecute(IProgressMonitor monitor, IAdaptable info) throws Exception {
      childNode = PolytomousKeyNode.NewInstance();
      parentNode.addChild(childNode);
      if (postOperationEnabled.postOperation(childNode)){
          return childNode;
      }else {
          return null;
      }
    }






}
