package eu.etaxonomy.taxeditor.editor.view.concept.handler;

import org.eclipse.ui.PartInitException;

import eu.etaxonomy.cdm.model.taxon.TaxonBase;
import eu.etaxonomy.taxeditor.bulkeditor.BulkEditorUtil;
import eu.etaxonomy.taxeditor.model.MessagingUtils;

public class OpenRelatedConceptInBulkEditorHandler extends OpenRelatedConceptHandler{
    /**
     * {@inheritDoc}
     */
    @Override
    protected void openConcept(TaxonBase<?> relatedTaxon) {
        try {
            BulkEditorUtil.openEditor(relatedTaxon);
        } catch (PartInitException e) {
            MessagingUtils.error(this.getClass(), "Bulk Editor could not be opened for "+relatedTaxon, e);
        }
    }
}
