
package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import javax.inject.Inject;

import org.eclipse.e4.ui.workbench.modeling.EModelService;

import eu.etaxonomy.cdm.model.media.Media;
import eu.etaxonomy.cdm.model.molecular.DnaSample;
import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;
import eu.etaxonomy.cdm.model.occurrence.FieldUnit;
import eu.etaxonomy.cdm.model.occurrence.MediaSpecimen;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationType;

public class AddMediaSpecimenHandler extends AbstractAddDerivativeHandler{

//    @Inject
//    private EModelService modelService;

    @Override
    protected boolean isAllowed(Object derivative) {
        if(derivative instanceof FieldUnit
                || (derivative instanceof DerivedUnit && ((DerivedUnit) derivative).getRecordBasis().equals(SpecimenOrObservationType.PreservedSpecimen))
                || (derivative instanceof DnaSample && ((DnaSample)derivative).getRecordBasis()==SpecimenOrObservationType.TissueSample)
                || (derivative instanceof DnaSample && ((DnaSample)derivative).getRecordBasis()==SpecimenOrObservationType.DnaSample)){
            return true;
        }
        return false;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivedUnit createDerivative() {
    	MediaSpecimen mediaSpecimen =  MediaSpecimen.NewInstance(SpecimenOrObservationType.StillImage);
    	mediaSpecimen.setMediaSpecimen(Media.NewInstance());
        return mediaSpecimen;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivationEventType getDerivationeType() {
        return DerivationEventType.ACCESSIONING();
    }

}