
package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import eu.etaxonomy.cdm.api.application.CdmApplicationState;
import eu.etaxonomy.cdm.model.molecular.Sequence;
import eu.etaxonomy.cdm.model.molecular.SingleRead;
import eu.etaxonomy.cdm.model.occurrence.DerivationEventType;
import eu.etaxonomy.cdm.model.occurrence.DerivedUnit;

public class AddSingleReadHandler extends AbstractAddDerivativeHandler{

    @Override
    protected boolean isAllowed(Object derivative) {
        if(derivative instanceof Sequence){
            return true;
        }
        return false;
    }


    /**
     * {@inheritDoc}
     */
    @Override
    protected Object addElement(Object selectedDerivative) {
        SingleRead newInstance = SingleRead.NewInstance();
        ((Sequence) selectedDerivative).addSingleRead(newInstance);
        CdmApplicationState.getCurrentAppConfig().getSequenceService().merge((Sequence)selectedDerivative, true);
        return newInstance;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivedUnit createDerivative() {
        //not used here
        return null;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected DerivationEventType getDerivationeType() {
        //not used here
        return null;
    }

}