package eu.etaxonomy.taxeditor.editor.view.derivate.handler;

import javax.inject.Named;

import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MHandledMenuItem;
import org.eclipse.e4.ui.services.IServiceConstants;

import eu.etaxonomy.taxeditor.editor.l10n.Messages;
import eu.etaxonomy.taxeditor.editor.view.derivate.DerivateView;

public class ToggleLinkWithTaxonSelectionHandler {

    @Execute
    public void execute(@Named(IServiceConstants.ACTIVE_PART) MPart part){
        DerivateView derivateView = (DerivateView) part.getObject();
        derivateView.toggleListenToSelectionChange(part);
    }

    @CanExecute
    public boolean canExecute(@Named(IServiceConstants.ACTIVE_PART) MPart part, MHandledMenuItem item){
        DerivateView derivateView = (DerivateView) part.getObject();
        if(derivateView.isListenToSelectionChange()){
            item.setLabel(Messages.ToggleLinkWithTaxonSelectionHandler_UNLINK);
        }
        else{
            item.setLabel(Messages.ToggleLinkWithTaxonSelectionHandler_LINK);
        }
        return true;
    }
}
