package eu.etaxonomy.taxeditor.editor.view.media.handler;

import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.common.NotDefinedException;

import eu.etaxonomy.cdm.model.description.DescriptionBase;
import eu.etaxonomy.cdm.model.media.Media;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.view.media.operation.AddExistingMediaToImageGalleryOperation;
import eu.etaxonomy.taxeditor.model.AbstractUtility;
import eu.etaxonomy.taxeditor.model.MessagingUtils;
import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
import eu.etaxonomy.taxeditor.ui.dialog.selection.MediaSelectionDialog;

public class AddExistingMediaHandler extends CreateMediaHandler {

    /**
     * @param event
     * @param postOperationEnabled
     * @param description
     */
    @Override
    protected void executeOperation(ExecutionEvent event, IPostOperationEnabled postOperationEnabled,
            DescriptionBase description) {
        AbstractPostOperation operation = null;
        try {
            //select media
            Media media = MediaSelectionDialog.select(AbstractUtility.getShell(), null, null);
            if(media!=null){
                // TODO use undo context specific to editor
                operation = new AddExistingMediaToImageGalleryOperation(media, event.getCommand().getName(),
                        EditorUtil.getUndoContext(), description, postOperationEnabled);
                AbstractUtility.executeOperation(operation);
            }
        } catch (NotDefinedException e) {
            MessagingUtils.warn(getClass(), "Command name not set."); //$NON-NLS-1$
        }
    }

}
