/**
 * Copyright (C) 2011 EDIT
 * European Distributed Institute of Taxonomy
 * http://www.e-taxonomy.eu
 *
 * The contents of this file are subject to the Mozilla Public License Version 1.1
 * See LICENSE.TXT at the top of this package for the full license terms.
 */

package eu.etaxonomy.taxeditor.editor.view.uses.handler;

import org.eclipse.core.commands.ExecutionEvent;

import eu.etaxonomy.cdm.api.service.ITermService;
import eu.etaxonomy.cdm.model.description.DescriptionBase;
import eu.etaxonomy.cdm.model.description.Feature;
import eu.etaxonomy.taxeditor.editor.EditorUtil;
import eu.etaxonomy.taxeditor.editor.view.descriptive.handler.CreateDescriptionElementHandler;
import eu.etaxonomy.taxeditor.editor.view.uses.operation.CreateUseRecordOperation;
import eu.etaxonomy.taxeditor.operation.AbstractPostOperation;
import eu.etaxonomy.taxeditor.operation.IPostOperationEnabled;
import eu.etaxonomy.taxeditor.store.CdmStore;
import eu.etaxonomy.taxeditor.store.UsageTermCollection;
import eu.etaxonomy.taxeditor.store.UseObjectStore;

/**
 * CreateUseRecordHandler Class
 * @author a.theys
 * @created mar 13, 2012
 * @version 1.0
 */
public class CreateUseRecordHandler extends CreateDescriptionElementHandler {
	/** {@inheritDoc} */
	@Override
	protected AbstractPostOperation operationCreationInstance(String label, ExecutionEvent event, DescriptionBase<?> description, IPostOperationEnabled postOperationEnabled) {
		//Use Record Feature retrieval below
		Feature feature = UseObjectStore.getUseRecordFeature();
		feature.setSupportsCategoricalData(true);
		return new CreateUseRecordOperation(label,
					EditorUtil.getUndoContext(),
					description, feature, postOperationEnabled);
	}



}
